program main
use constants
implicit none
character(len=100)::Input_file,filename1,filename2,char_tmp
integer::i
real*8::mag
call cpu_time(time_start)



call getarg(1,Input_file)

OPEN(UNIT=unit_input,FILE=Input_file,FORM='FORMATTED',STATUS='OLD',ACCESS='SEQUENTIAL',ACTION='READ')
do i=1, 11
    read(unit_input,*)char_tmp
enddo

    read(unit_input,*)filename2
    Output_file=trim(filename2)


char_tmp='_log.txt'
log_file=Output_file(1:(LEN_TRIM(Output_file)-4))//char_tmp
OPEN(UNIT=unit_log,FILE=log_file,FORM='FORMATTED',STATUS='REPLACE',ACCESS='SEQUENTIAL')
WRITE(unit_log,"('**********************************')")
WRITE(unit_log,"('Full Diffusion Code')")
WRITE(unit_log,"('**********************************')")
WRITE(unit_log,"(/)")
WRITE(unit_log,"('Input file name:' 4X,A30)")Input_file
WRITE(unit_log,"(/)")
WRITE(unit_log,"('**********Start initialization**********')")
WRITE(unit_log,"(/)")
WRITE(unit_log,"('Output file name:' 4X,A30)")Output_file
WRITE(unit_log,"('log file name:' 4X,A30)")log_file

    read(unit_input,*)char_tmp
    read(unit_input,*)char_tmp
    PT=trim(char_tmp)

        read(unit_input,*)char_tmp
        read(unit_input,*)mag
    select case(PT)
        case('Jupiter')
            B0=4.2818e-4   !for Jupiter
        case('Earth')
            B0=2.997527836235779e-5 !for Earth
        case('Saturn')
            B0=0.2e-4  !for Saturn
        case('Dipole','DIPOLE')
            B0=mag*1e-9
        CASE DEFAULT
            WRITE(*,*) 'Invalid Planet.'
            STOP
    END SELECT
WRITE(unit_log,"('Planet:' 4X,A10)")PT

    read(unit_input,*)char_tmp
    read(unit_input,*)NPA,NE,NL


    read(unit_input,*)char_tmp
    read(unit_input,*)L_min,L_max
        L_min=L_min/10.0
        L_max=L_max/10.0
WRITE(unit_log,"('Number of Lshell:' 4X, I4)")NL
WRITE(unit_log,"('Minimum of Lshell:' 4X, f5.2)")L_min
WRITE(unit_log,"('Maximum of Lshell:' 4X, f5.2)")L_max
    
        read(unit_input,*)char_tmp
    read(unit_input,*)E_min,E_max
WRITE(unit_log,"('Number of Energy:' 4X, I4)")NE
WRITE(unit_log,"('Minimum of Energy:' 4X, f5.2, 1X 'keV')")E_min
WRITE(unit_log,"('Maximum of Energy:' 4X, f10.1, 1X 'keV')")E_max

    read(unit_input,*)char_tmp
    read(unit_input,*)PA_min,PA_max
WRITE(unit_log,"('Number of Pitch Angle:'4X,I4)")NPA
WRITE(unit_log,"('Minimum of Pitch Angle:' 4X, f5.2, 1X 'Degree')")PA_min
WRITE(unit_log,"('Maximum of Pitch Angle:' 4X, f5.2, 1X 'Degree')")PA_max

    read(unit_input,*)char_tmp
    read(unit_input,*)Kp10,MLT
WRITE(unit_log,"('Kp10:',4X,f5.2)")Kp10
Kp=Kp10/10.0
WRITE(unit_log,"('Magnetic Local Time:'4X,f5.2)")MLT

    read(unit_input,*)char_tmp
    read(unit_input,*)NresType,Nres_min,Nres_max
   select case(NresType)
        case('Constant','CONSTANT','constant')
                WRITE(unit_log,"('resonance type:'4X,A10)")NresType
                WRITE(unit_log,"('Minimum resonance order:'4X,I3)")Nres_min
                WRITE(unit_log,"('Maximum resonance order:'4X,I3)")Nres_max
        case('MR12','Mr12','mR12','mr12')
                WRITE(unit_log,"('resonance type:'4X,A10)")NresType
                WRITE(unit_log,"('Minimum and Maximum resonance order are determined by equation 22 in MR 2012')")
        CASE DEFAULT
                WRITE(unit_log,"('Invalid resonance type:'4X,A10)")NresType
                STOP
    END SELECT
    read(unit_input,*)char_tmp
    read(unit_input,*)DenModel,DenValue,DenLatINdex
        SELECT CASE(DenModel)
        CASE('Sheely01','SHEELY01','sheely01') 
                WRITE(unit_log,"('electron density model:    Sheely et al. 2001')")
        CASE('CA92', 'Ca92', 'cA92', 'ca92') 
                WRITE(unit_log,"('electron density model:    Carpenter and Anderson 1992')")
        CASE('DENTON06', 'Denton06', 'denton06') 
                WRITE(unit_log,"('electron density model:    Denton et al. 2004 2006')")
        CASE('CONSTANT', 'Constant', 'constant') 
                WRITE(unit_log,"('electron density:'4x,f8.4,1x'cm^-3')")DenValue
        CASE('NbbLBUB')
                WRITE(unit_log,"('Nbb PAPER')")
        CASE('XD_Saturn')
                write(unit_log,"('see Gu et al. 2012 paper')")
        CASE DEFAULT
                WRITE(unit_log,"('Invalid density type'4x,A10)")DenModel
                STOP
        END SELECT
        WRITE(unit_log,"('index of density latitudinal variation:'4X,f5.2)")DenLatINdex

    read(unit_input,*)char_tmp
    read(unit_input,*)FreqDistribution
        select case(FreqDistribution)
        case('GAUSSIAN','Gaussian')
        case('2016Hiss','2016HISS')
        case('2017Chorus','2017CHORUS')
        case('2018UBChorus')
        case('2018LBChorus')
        case default
        stop
        end select 


    read(unit_input,*)char_tmp
    read(unit_input,*)FreqUnit,omega_m_per,d_omega_per,o_lc,o_uc
    FreqUnit=trim(FreqUnit)
        SELECT CASE(FreqUnit)
        CASE('HZ','Hz','hZ','hz') 
                WRITE(unit_log,"('f_m=' f7.2,1X 'Hz,' 1X 'f_w=' f7.2,1X 'Hz,' 1X 'f_l=' f7.2,1X 'Hz,' 1X 'f_u=' f7.2,1X 'Hz')")omega_m_per, d_omega_per, o_lc, o_uc
        CASE('ratio', 'Ratio', 'RATIO') 
                WRITE(unit_log,"('omega_m/Omega_e=' f7.2,1X ',' 1X 'delta_omega/Omega_e=' f7.2,1X ',' 1X 'omega_lc/Omega_e=' f7.2,1X ',' 1X 'omega_uc/Omega_e=' f7.2,1X)")omega_m_per, d_omega_per,  o_lc, o_uc
        CASE('NbbLBC','NbbUBC')
        CASE('2016Hiss','2016HISS')
        CASE('2017Chorus','2017CHORUS')
        CASE('2018LBChorus')
        CASE('18UBChorus')
        CASE DEFAULT
                WRITE(unit_log,"('Invalid Frequency Unit.'4x,A10)") FreqUnit
                STOP
        END SELECT


    read(unit_input,*)char_tmp
    read(unit_input,*)nint,nint_X,nint_N
    nint_zero_res=3*nint
    nint_N_res_cone=3*nint_N
        WRITE(unit_log,"('Points of latitude:'4X,I4)")nint
        WRITE(unit_log,"('Points of normal angle distribution:' 4X,I4)")nint_X
        WRITE(unit_log,"('Points of normalized factor:' 4X,I4)")nint_N

    read(unit_input,*)char_tmp
    read(unit_input,*)lam_min,lam_max
        WRITE(unit_log,"('Minimum of latitude:' 4X, f5.2, 1X 'Degree')")lam_min
        WRITE(unit_log,"('Maximum of latitude:' 4X, f5.1, 1X 'Degree')")lam_max

    read(unit_input,*)char_tmp
    read(unit_input,*)BwType,Bw_Input
    BwType=trim(BwType)
        
        SELECT CASE(BwType)
        CASE('TypicalDaysideChorus','TypicalNightsideChorus','TypicalHiss','KS14DaysideHiss','KS14NightsideHiss','2016DaysideChorus','2016NightsideChorus','2016NightsideChorus2') 
                WRITE(unit_log,"('wave amplitude type:'4x,A30)")BwType
        CASE('Constant','CONSTANT','constant') 
                WRITE(unit_log,"('wave amplitude type:'4x,A30)")BwType
                WRITE(unit_log,"('wave amplitude:' 4X, f8.3, 1x 'pT')")Bw_Input
        CASE('NbbLBC','NbbUBC')
        CASE('OA2015')
        CASE('VitaliiChorus','VITALIICHORUS')
        CASE('2016Hiss','2016HISS')
        case('2017Chorus','2017CHORUS')
        CASE('2017UpperBandChorus')
        CASE('2018ChorusLat1545')
        CASE('2018UBChorus')        
        case('2018LBChorus')
        case('MidLatChorus')
        CASE DEFAULT
                WRITE(unit_log,"('Invalid Wave Amplitude Type:' 4x, A30)") BwType
                STOP
        END SELECT

    read(unit_input,*)char_tmp
    read(unit_input,*)ThetaType,Theta_Input
    ThetaType=trim(ThetaType)
        SELECT CASE(ThetaType)
        CASE('Constant') 
                WRITE(unit_log,"('normal angle model type:'4x,A10)")ThetaType
                WRITE(unit_log,"('theta_m=' f4.1,1X 'deg,' 1X, 'theta_w=' f4.1,1X 'deg,' 1X, 'theta_lc=' f4.1,1X 'deg,' 1X 'theta_uc=' f4.1,1X 'deg.')")Theta_Input
        CASE('ObliqueHiss') 
                WRITE(unit_log,"('normal angle model type:'4x, A10)")ThetaType
        CASE('OA2015')
                WRITE(unit_log,"('normal angle model type:'4x, A10)")ThetaType
        CASE('NbbLBC','NbbUBC')
        CASE('VitaliiChorus','VITALIICHORUS')
        CASE DEFAULT
                WRITE(unit_log,"('Invalid Theta Type:' 4x, A10)") 
                STOP
        END SELECT

close(unit_input)
WRITE(unit_log,"('**********End initialization**********')")
WRITE(unit_log,"(/)")
WRITE(unit_log,"('**********Start calculation**********')")
WRITE(unit_log,"(/)")

call mpi_parallel()

call cpu_time(time_finish)
WRITE(unit_log,"('**********End calculation**********')")
WRITE(unit_log,"(/)")
WRITE(unit_log, "('Calculation Time = ',f8.3,' seconds.')")time_finish-time_start
WRITE(unit_log,"(/)")

end program main
